Test the Framework
==================

[←](../index.md)

In this part, you are going to develop a web application with Danf to help people find their corresponding framework! The user will be asked to answer some questions in order to compute a compatibility score with different frameworks. It will allow you to see the framework in action and have an overview on the main features. In each of the following sections, you will be able to navigate to the corresponding [documentation](../use/index.md) section to deepen your understanding.

The main goal is not to make the perfect architecture or a performant application but to show some of the possibilities of the framework.

The code of this tutorial is available [here](../../test/functional/tutorial).

* [Start a new application](app.md)
* [Define the configuration](configuration.md)
* [Develop with object-oriented programming](object.md)
* [Use dependency injection](dependency-injection.md)
* [Extend to the client side](client-side.md)
* [Master the events](events.md)
* [Handle assets](assets.md)
* [Make an ajax app](ajax-app.md)
* [Code unit tests](tests.md)

[←](../index.md)